local function FireChatEvent(evt, a1,a2,a3,a4,a5,a6,a7,a8,a9)
  
  local bIsChat = (strsub(evt, 1,9)=="CHAT_MSG_");
  local chattype = strsub(evt, 10); --might just be garbage if bIsChat==false, but in that case we don't use it

  local b1,b2,b3,b4,b5,b6,b7,b8,b9 = arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9;
  local oldevent = event;
  local oldthis = this;
  
  for i=1,NUM_CHAT_WINDOWS do
    if(not bIsChat or HealHelp_UserVars.Chat[chattype][i]) then
      this = getglobal("ChatFrame"..i);
      event=evt;
      arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9 = a1,a2,a3,a4,a5,a6,a7,a8,a9;
      ChatFrame_OnEvent(evt);
    end
  end

  arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9 = b1,b2,b3,b4,b5,b6,b7,b8,b9;
  event=oldevent;
  this=oldthis;		
end

local ORIG_GetChatWindowMessages = GetChatWindowMessages;
function GetChatWindowMessages(n)
  ret = { ORIG_GetChatWindowMessages(n) };
  for chattype,settings in pairs(HealHelp_UserVars.Chat) do
    if(settings[n]) then
      tinsert(ret, chattype);
    end
  end
  return unpack(ret);
end


local ORIG_AddChatWindowMessages = AddChatWindowMessages;
function AddChatWindowMessages(n, chattype)
  if(HealHelp_UserVars.Chat[chattype]) then
    HealHelp_UserVars.Chat[chattype][n]=true;
  else
    ORIG_AddChatWindowMessages(n,chattype);
  end
end


local ORIG_RemoveChatWindowMessages = RemoveChatWindowMessages;
function RemoveChatWindowMessages(n, chattype)
  if(HealHelp_UserVars.Chat[chattype]) then
    HealHelp_UserVars.Chat[chattype][n]=false;
  else
    ORIG_RemoveChatWindowMessages(n,chattype);
  end
end


local ORIG_ChangeChatColor = ChangeChatColor;
function ChangeChatColor(chattype, r,g,b)
  if(HealHelp_UserVars.Chat[chattype]) then
    HealHelp_UserVars.Chat[chattype].r=r;
    HealHelp_UserVars.Chat[chattype].g=g;
    HealHelp_UserVars.Chat[chattype].b=b;
    FireChatEvent("UPDATE_CHAT_COLOR", chattype, r,g,b);
  else
    ORIG_ChangeChatColor(chattype,r,g,b);
  end
end


function HealHelp_Msg(chattype, txt)
  assert(HealHelp_UserVars.Chat[chattype]);
  FireChatEvent("CHAT_MSG_"..chattype, txt, "", "", "", "", "", "", "", "");
end

function HealHelp_OnEvent()
  if(event=="VARIABLES_LOADED") then
    if(not HealHelp_UserVars) then HealHelp_UserVars = {}; end
    if(not HealHelp_UserVars.Chat) then
      HealHelp_UserVars.Chat={
        ["HealHelpMSG"] = { [1]=true; r=1; g=0.7; b=0.3; }
      }
    end
  

    -- Insert our chat types in the ChatFrame system
    CHAT_MSG_HealHelpMSG="HealHelp";   -- Displayed in menu
    CHAT_HealHelpMSG_GET = "";   -- ChatFrame needs it. Never mind it.
  
    for chattype,info in HealHelp_UserVars.Chat do
      ChatTypeGroup[chattype] = {
        "CHAT_MSG_"..chattype
      };
      ChatTypeInfo[chattype] = info;
      tinsert(OtherMenuChatTypeGroups, chattype);
    end
  end
  if(event=="PLAYER_ENTERING_WORLD") then
	HealHelp_GatherData();
  end
  
end